/*
Explains the scope concept. How local variables are treated.
*/
#include <iostream>

using namespace std;

void valfun() 
{	
	int firstnum;
	int secnum;		// create a second local variable named secnum
	firstnum = 40;	// this only affects this local variable's value
	secnum = 30;	// this only affects this local variable's value

	cout << endl << "  [valfun() function] firstnum = " << firstnum << endl;
	cout << "  [valfun() function] secnum = " << secnum << endl;
}

void paramfun(int firstnum, int secnum) 
{	
   	cout << endl << "  [paramfun() function beginning] firstnum = " << firstnum << endl;
	cout << "  [paramfun() function beginning] secnum = " << secnum << endl;

	firstnum = 100;
	secnum = 101;
	
	cout << endl << "  [paramfun() function end] firstnum = " << firstnum << endl;
	cout << "  [paramfun() function end] secnum = " << secnum << endl;
}

int main() 
{	
	int firstnum; //create a local variable named firstnum
	int secnum;   //create a local variable named secnum

	firstnum = 10; 
	secnum = 20;

	cout << "Starting..." << endl << endl;

	cout << "  [main() function] firstnum = " << firstnum << endl;
	cout << "  [main() function] secnum = " << secnum << endl;

	valfun();

	cout << endl << "After valfun() finished..." << endl;

	cout << endl << "  [main() function] firstnum = " << firstnum << endl;
	cout << "  [main() function] secnum = " << secnum << endl;

	paramfun(firstnum, secnum);

	cout << endl << "After paramfun() finished..." << endl;
	
	cout << endl << "  [main() function] firstnum = " << firstnum << endl;
	cout << "  [main() function] secnum = " << secnum << endl << endl;

	/* 
	 * a variable that is defined inside a code block can be used only in
	 * that code block; not outside it. 
	 */
	
	if (firstnum < 100)
	{
		int thirdnum = 30;

		cout << "  [Inside IF statement] thirdnum = " << thirdnum << endl << endl;
	}

	/*
	 * remove comment and compile program to see what happens when we try to use
	 * thirdnum outside IF code block.
     */

	// cout << "[Outside IF statement] thirdnum = " << thirdnum << endl << endl;

	return 0;
}